# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`deferred_resources`](#deferred_resources): **WARNING:** This module is intended to help meet common policy requirements for packages being either present or absent on a system and is n
* [`deferred_resources::packages`](#deferred_resourcespackages): This class takes two `Hashes` of packages, one to remove and one to install.  After the entire puppet catalog has been compiled, it will proc

**Resource types**

* [`deferred_resources`](#deferred_resources): WARNING: This type is **NOT** meant to be called directly. Please use the helper classes in the module.  This type will process after the cat

## Classes

### deferred_resources

**WARNING:** This module is intended to help meet common policy requirements
for packages being either present or absent on a system and is not meant for
general usage. Make sure you understand the ramifications of what this module
does to the Puppet catalog prior to using it outside of the SIMP framework.

#### Parameters

The following parameters are available in the `deferred_resources` class.

##### `$mode`

If set to `enforcing` then the management classses will take action on the
system. If set to 'warning' a message will be printed noting what would
have taken place on the system but the catalog will not be updated.

##### `$log_level`

Set the log level for warning messages

##### `mode`

Data type: `Enum['warning','enforcing']`



Default value: 'warning'

##### `log_level`

Data type: `Simplib::PuppetLogLevel`



Default value: 'info'

### deferred_resources::packages

This class takes two `Hashes` of packages, one to remove and one to install.

After the entire puppet catalog has been compiled, it will process both lists
and, for any resource that is not already defined in the catalog, it will
take the appropriate action.

An exception will be raised if you list the same package in both lists.

#### Parameters

The following parameters are available in the `deferred_resources::packages` class.

##### `$remove`

A list of packages to remove.

* A `Hash` can be used to add extra attributes for the package, but the
  `ensure` attribute will be overwritten if it is included.

##### `$install`

A list of packages to install.

* A `Hash` can be used to add extra attributes for the package, but the
  `ensure` attribute will always be set to `$package_ensure`.

##### `$install_ensure`

If installing, then this is the state that the packages should have.

* This will be overridden by anything set in options applied to an entry in
  the `$install` Hash.

##### `$default_options`

A `Hash` of options to apply to all packages (both remove and install.
If ensure is entered in these options it will be overwritten.

* These options may be anything that a Puppet `Package` resource can
  normally accept.

##### `$mode`

@see `deferred_resources::mode`

##### `$log_level`

@see `deferred_resources::log_level`

##### `remove`

Data type: `Variant[Hash, Array]`



Default value: {}

##### `install`

Data type: `Variant[Hash, Array]`



Default value: {}

##### `install_ensure`

Data type: `Enum['latest','present','installed']`



Default value: simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })

##### `default_options`

Data type: `Hash`



Default value: {}

##### `mode`

Data type: `Enum['warning','enforcing']`



Default value: $deferred_resources::mode

##### `log_level`

Data type: `Simplib::PuppetLogLevel`



Default value: $deferred_resources::log_level

## Resource types

### deferred_resources

WARNING: This type is **NOT** meant to be called directly. Please use the
helper classes in the module.

This type will process after the catalog has been compiled but before it
is applied.  It takes a list of resources and checks for the existence of
that resource in the compiled catalog. If the resource has already been
defined in the catalog, it prints out a message that an action will
not be performed.

If mode is set to `warning`, instead of adding resources to the catalog,
it prints out a list of resources that would have been added.

#### Parameters

The following parameters are available in the `deferred_resources` type.

##### `name`

namevar

Unique name for this resource.

##### `default_options`

A Hash of options to be used for all resources.

Default value: Hash.new

##### `resource_type`

Valid values: /.+/

The type of Puppet resource that will be passed in :resources

##### `resources`

A Hash or Array of resources to add to the catalog.

##### `log_level`

Valid values: alert, crit, debug, notice, emerg, err, info, warning

Set the message log level for notifications.

Default value: warning

##### `mode`

Valid values: enforcing, warning

`enforcing` => Actually add the resource to the catalog post-compilation
`warning`   => Tell the user what would be done but do not actually alter
               the catalog.

Default value: warning

